!DIR$ FIXEDFORMLINESIZE:132
      pure subroutine make_cF(Mode, cq, cF)
      use dblocks
      implicit none
      integer*4,  intent(in)  :: Mode
      complex*16, intent(in)  :: cq(1:3)
      complex*16, intent(out) :: cF

      complex*16 b(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx)
      complex*16 mu(0:nord), cq_new(1:3)
      complex*16 sigma, eta_xx, eta_yy, eta_zz, xi_xy, xi_xz, xi_yz
      integer*4  iord
      
      interface
         pure subroutine make_bx(cq, b)
         use dblocks
         complex*16, intent(in)  :: cq(1:3)
         complex*16, intent(out) ::  b(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx)
         end subroutine make_bx

         pure subroutine make_by(cq, b)
         use dblocks
         complex*16, intent(in)  :: cq(1:3)
         complex*16, intent(out) ::  b(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx)
         end subroutine make_by

         pure subroutine make_bz(cq, b)
         use dblocks
         complex*16, intent(in)  :: cq(1:3)
         complex*16, intent(out) ::  b(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx)
         end subroutine make_bz

         pure subroutine make_mux(cq, b, mu, iord)
         use dblocks
         complex*16, intent(in)  :: cq(1:3)
         complex*16, intent(in)  ::  b(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx)
         complex*16, intent(out) :: mu(0:nord)
         integer*4 , intent(out) :: iord
         end subroutine make_mux

         pure subroutine make_muy(cq, b, mu, iord)
         use dblocks
         complex*16, intent(in)  :: cq(1:3)
         complex*16, intent(in)  ::  b(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx)
         complex*16, intent(out) :: mu(0:nord)
         integer*4 , intent(out) :: iord
         end subroutine make_muy

         pure subroutine make_muz(cq, b, mu, iord)
         use dblocks
         complex*16, intent(in)  :: cq(1:3)
         complex*16, intent(in)  ::  b(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx)
         complex*16, intent(out) :: mu(0:nord)
         integer*4 , intent(out) :: iord
         end subroutine make_muz

         pure subroutine make_sig(iord, mu, sig)
         use dblocks
         integer*4 , intent(in)  :: iord
         complex*16, intent(in)  :: mu(0:nord)
         complex*16, intent(out) :: sig
         end subroutine make_sig

      end interface


      xi_xy = cz
      xi_xz = cz
      xi_yz = cz

      if    (Mode .eq. 1) then

         call make_bx (cq, b)
         call make_mux(cq, b, mu, iord)
         call make_sig(iord, mu, sigma)
         eta_xx = ceps_a + ceps_h*chi*sigma
         cF     = eta_xx

      else if(Mode .eq. 2) then

         call make_by (cq, b)
         call make_muy(cq, b, mu, iord)
         call make_sig(iord, mu, sigma)
         eta_yy = ceps_a + ceps_h*chi*sigma
         cF     = eta_yy

      else if(Mode .eq. 3) then

         call make_by (cq, b)
         call make_muy(cq, b, mu, iord)
         call make_sig(iord, mu, sigma)
         eta_yy = ceps_a + ceps_h*chi*sigma

         cF = eta_yy - fkx2

      else if(Mode .eq. 4) then

         call make_bx (cq, b)
         call make_mux(cq, b, mu, iord)
         call make_sig(iord, mu, sigma)
         eta_xx = ceps_a + ceps_h*chi*sigma

         call make_bz (cq, b)
         call make_muz(cq, b, mu, iord)
         call make_sig(iord, mu, sigma)
         eta_zz = ceps_a + ceps_h*chi*sigma

         cq_new = cq
         if(cdabs(cq(3)) .lt. qthr) cq_new(3)=qthr
         call make_mux(cq_new, b, mu, iord)
         call make_sig(iord, mu, sigma)
         xi_xz = ru + ceps_h*chi*rk2*sigma / (rkx*cq_new(3)) 

         cF = eta_xx*(eta_zz - fkx2) / (eta_zz + (xi_xz*xi_xz - ru)*fkx2)

      else if(Mode .eq. 5) then

         call make_bx (cq, b)
         call make_mux(cq, b, mu, iord)
         call make_sig(iord, mu, sigma)
         eta_xx = ceps_a + ceps_h*chi*sigma
         cF = eta_xx - fky2

      else if(Mode .eq. 6) then

         call make_by (cq, b)
         call make_muy(cq, b, mu, iord)
         call make_sig(iord, mu, sigma)
         eta_yy = ceps_a + ceps_h*chi*sigma

         call make_bz (cq, b)
         call make_muz(cq, b, mu, iord)
         call make_sig(iord, mu, sigma)
         eta_zz = ceps_a + ceps_h*chi*sigma

         cq_new = cq
         if(cdabs(cq(3)) .lt. qthr) cq_new(3)=qthr
         call make_muy(cq_new, b, mu, iord)
         call make_sig(iord, mu, sigma)
         xi_yz = ru + ceps_h*chi*rk2*sigma / (rky*cq_new(3)) 

         cF = eta_yy*(eta_zz - fky2) / (eta_zz + (xi_yz*xi_yz - ru)*fky2)

      else if(Mode .eq. 7) then

         cF = cz
         return

      else

         cF = cz
         return

      end if

      return
      end
