!DIR$ FIXEDFORMLINESIZE:132
      pure subroutine solve_ratA(pind, Mode, Niter, cq_ini, cq_sol, info)
      use dblocks
      implicit none
      integer*4,  intent(in)  :: pind, Mode, Niter
      complex*16, intent(in)  :: cq_ini(1:3)
      complex*16, intent(out) :: cq_sol(1:3)
      integer*4 , intent(out) :: info

      complex*16 cnum, cden, cqz, cF, F1, F2, F3, z1, z2, z3, cq(1:3)
      real*8     test
      integer*4  iter

      interface
         pure subroutine make_cF(Mode, cq, cF)
         use dblocks
         integer*4,  intent(in)    :: Mode
         complex*16, intent(inout) :: cq(1:3)
         complex*16, intent(out)   :: cF
         end subroutine make_cF

         pure subroutine make_points(pind, Mode, cq_in, z1, z2, z3, F1, F2, F3, info)
         use dblocks
         integer*4 , intent(in)  :: pind, Mode
         complex*16, intent(in)  :: cq_in(1:3)
         complex*16, intent(out) :: z1, z2, z3
         complex*16, intent(out) :: F1, F2, F3
         integer*4 , intent(out) :: info
         end subroutine make_points
      end interface

      cq(1)= rkx
      cq(2)= rky

      call make_points(pind, Mode, cq_ini, z1, z2, z3, F1, F2, F3, info)

      if     (info .eq. 1) then
         cq(3)  = z1
         cq_sol = cq
         return
      else if(info .eq. 2) then
         cq(3)  = z2
         cq_sol = cq
         return
      else if(info .eq. 3) then
         cq(3)  = z3
         cq_sol = cq
         return
      end if

      do 100, iter=1,Niter

      cnum = z1*(z2-z3)*F2*F3 + z3*(z1-z2)*F1*F2 + z2*(z3-z1)*F1*F3
      cden = (z1-z2)*F1*F2 + (z2-z3)*F2*F3 + (z3-z1)*F1*F3
      cqz  = cnum / cden
      cq(3)= cqz
      call make_cF(Mode, cq, cF)
      cF = cqz*cqz - rk2*cF
      test = cdabs(cF)
      if(test .le. eps) then
         cq(3)  = cqz
         cq_sol = cq
         info   = iter
         return
      end if

      z1 = z2
      F1 = F2
      z2 = z3
      F2 = F3
      z3 = cqz
      F3 = cF

 100  continue

      info = -1
      return

      end
